diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 2383491e3..f13f5ef15 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -30,9 +30,9 @@ import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.client.render.block.model.BlockModelGrass;
 import net.minecraft.client.render.font.FontDefault;
-import net.minecraft.client.render.font.FontMonospace;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.font.FontRendererDefault;
+import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.core.achievement.Achievements;
@@ -313,7 +313,7 @@ public class Minecraft
         this.gameSettings = new GameSettings(this, mcDataDir);
         this.texturePackList = new TexturePackList(this, this.mcDataDir);
         this.textureManager = new TextureManager(this, this.texturePackList, this.gameSettings);
-        this.font = new FontRendererDefault(new FontDefault(this.textureManager));
+        this.font = new FontRendererDefault();
 
         if(test) return;
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java b/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
index 768e35691..2abe35c8f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
@@ -51,7 +51,7 @@ public class ExceptionPopupElement {
 
 
         PopupScreen popup = new PopupBuilder(parent,860/scale).withLabel("gui.exception.label.exception_occurred")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.charWidth('m'))
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getFont().charWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.back","gui.exception.button.copy_error"},new int[]{0,1})
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
                 .build();
@@ -95,7 +95,7 @@ public class ExceptionPopupElement {
         ScreenBlank screen = new ScreenBlank();
         mc.displayScreen(screen);
         PopupScreen popup = new PopupBuilder(screen,860/scale).withLabel("gui.exception.label.fatal_error")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.charWidth('m'))
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getFont().charWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.copy_error","gui.exception.button.copy_error_and_quit"},new int[]{0,2},new boolean[]{false,true})
                 .withBackgroundColor(0xff402020, 0xff501010)
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
@@ -140,7 +140,7 @@ public class ExceptionPopupElement {
         ScreenBlank screen = new ScreenBlank();
         mc.displayScreen(screen);
         PopupScreen popup = new PopupBuilder(screen,860/scale).withLabel("gui.exception.label.startup_error")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.charWidth('m'))
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getFont().charWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.copy_error","gui.exception.button.copy_error_and_quit"},new int[]{0,2},new boolean[]{false,true})
                 .withBackgroundColor(0xff402020, 0xff501010)
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Gui.java b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
index b3abca07c..f9d726850 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
@@ -4,7 +4,6 @@ import static org.lwjgl.opengl.GL11.*;
 
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texture.meta.gui.GuiTextureProperties;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
@@ -218,23 +217,23 @@ public class Gui
     }
 
     public void drawStringCenteredShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
-        FontHelper.renderCentered(Tessellator.instance, chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call(fontRenderer);
+        fontRenderer.renderCentered(Tessellator.instance, chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call();
     }
     
     public void drawStringCenteredNoShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
-        FontHelper.renderCentered(Tessellator.instance, chars, x, y).setZ(this.zLevel).setColor(argb).call(fontRenderer);
+        fontRenderer.renderCentered(Tessellator.instance, chars, x, y).setZ(this.zLevel).setColor(argb).call();
     }
 
     public void drawStringShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
-        FontHelper.render(Tessellator.instance, chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call(fontRenderer);
+        fontRenderer.render(Tessellator.instance, chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call();
     }
     
     public void drawStringNoShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
-        FontHelper.render(Tessellator.instance, chars, x, y).setZ(this.zLevel).setColor(argb).call(fontRenderer);
+        fontRenderer.render(Tessellator.instance, chars, x, y).setZ(this.zLevel).setColor(argb).call();
     }
 
     public void drawStringConstrained(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int maxWidth, final int argb) {
-        FontHelper.renderWidthConstrained(Tessellator.instance, chars, x, y, maxWidth).setZ(this.zLevel).setColor(argb).call(fontRenderer);
+        fontRenderer.renderWidthConstrained(Tessellator.instance, chars, x, y, maxWidth).setZ(this.zLevel).setColor(argb).call();
     }
 
     public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height)
diff --git a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
index f0433812c..7bd5e1000 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
@@ -4,7 +4,6 @@ import static org.lwjgl.opengl.GL11.*;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.Option;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.client.util.helper.Colors;
@@ -128,7 +127,7 @@ public class HeldItemTooltipElement extends Gui {
 			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 		}
 
-		FontHelper.renderCentered(Tessellator.instance, this.string, x, y).setShadow().setColor(rgb).call(mc.font);
+		mc.font.renderCentered(Tessellator.instance, this.string, x, y).setShadow().setColor(rgb).call();
 
 		glDisable(GL_BLEND);
 		glEnable(GL_ALPHA_TEST);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
index f39fb603f..50f7557bd 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
@@ -11,7 +11,7 @@ import net.minecraft.client.render.font.FontMonospace;
 import net.minecraft.client.console.shell.RuntimeExecutor;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.font.FontRendererDefault;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.net.command.TextFormatting;
@@ -38,7 +38,7 @@ public class ScreenConsole extends Screen {
 
         private final @NotNull Map<LogMessage.@NotNull Level, @NotNull TextFormatting> preludes = new HashMap<>();
 
-        private @Nullable FontRenderer fontRenderer = null;
+        private final @NotNull FontRenderer fontRenderer = new FontRendererDefault(Fonts.MONOSPACE);
 
         private int width = 0;
         private int scroll = 0;
@@ -53,8 +53,6 @@ public class ScreenConsole extends Screen {
 
         public void init(final @NotNull Minecraft mc, final int width) {
             this.width = width;
-            this.fontRenderer = new FontRendererDefault(new FontMonospace(mc.textureManager));
-            this.fontRenderer.init(mc.texturePackList);
 
             initWorkedLines();
             final @NotNull List<@NotNull String> workedLine = new ArrayList<>();
@@ -76,9 +74,7 @@ public class ScreenConsole extends Screen {
             final int lines = Math.min(heightLines, WORKED_LINES.size() - this.scroll);
             for (int i = lines - 1; i >= 0; i--) {
                 final @NotNull String line = WORKED_LINES.get((WORKED_LINES.size() - 1) - (i + this.scroll));
-                if (this.fontRenderer != null) {
-                    FontHelper.render(Tessellator.instance, line, x, y + getHeight(numLines) - LINE_HEIGHT - LINE_HEIGHT * i).setColor(0xFF_CF_CF_CF).call(this.fontRenderer);
-                }
+                this.fontRenderer.render(Tessellator.instance, line, x, y + getHeight(numLines) - LINE_HEIGHT - LINE_HEIGHT * i).setColor(0xFF_CF_CF_CF).call();
             }
             renderScrollIndicator(x, y, numLines);
         }
@@ -139,10 +135,6 @@ public class ScreenConsole extends Screen {
         }
 
         private void formatString(final @NotNull LogMessage message, final @NotNull List<@NotNull String> out) {
-            if (this.fontRenderer == null) {
-                return;
-            }
-
             out.clear();
             final @NotNull String @NotNull[] workedString = message.getMessage()
                 .replace("\r\n", "\n")
@@ -164,9 +156,9 @@ public class ScreenConsole extends Screen {
                         if (newFormat != null) {
                             nextFormat = newFormat;
                         }
-                        lineWidth -= this.fontRenderer.charWidth(c) + this.fontRenderer.charWidth(trimmedLine.charAt(i + 1));
+                        lineWidth -= this.fontRenderer.getFont().charWidth(c) + this.fontRenderer.getFont().charWidth(trimmedLine.charAt(i + 1));
                     }
-                    final int cWidth = this.fontRenderer.charWidth(c);
+                    final int cWidth = this.fontRenderer.getFont().charWidth(c);
                     if (lineWidth + cWidth >= this.width) {
                         out.add(currentFormat.toString() + sb);
                         sb = new StringBuilder();
@@ -185,7 +177,7 @@ public class ScreenConsole extends Screen {
         private static final @NotNull List<@NotNull String> HISTORY = new ArrayList<>();
         private static final @Nullable RuntimeExecutor EXECUTOR = new RuntimeExecutor();
 
-        private @Nullable FontRenderer fontRenderer = null;
+        private final @NotNull FontRenderer fontRenderer = new FontRendererDefault(Fonts.MONOSPACE);
 
         private @NotNull String text = "";
         private @NotNull String highlightedText = "";
@@ -200,18 +192,11 @@ public class ScreenConsole extends Screen {
             this.editor = new TextFieldEditor(this, true);
         }
 
-        public void init(final @NotNull Minecraft mc) {
-            this.fontRenderer = new FontRendererDefault(new FontMonospace(mc.textureManager));
-            this.fontRenderer.init(mc.texturePackList);
-        }
-
         public void tick() {
             this.cursorCounter++;
         }
 
         public void render(final int x, final int y) {
-            if (this.fontRenderer == null) return;
-
             boolean addedStart = false;
             final @NotNull String @NotNull[] splitHighlighted = this.highlightedText.split("\n", -1);
             for (int i = 0; i < splitHighlighted.length; i++) {
@@ -239,8 +224,6 @@ public class ScreenConsole extends Screen {
         }
 
         public void click(final int mx, final int my) {
-            if (this.fontRenderer == null) return;
-
             final int oneChar = MathHelper.ceil(this.fontRenderer.stringWidthDouble(" "));
 
             final int cx = (mx - (oneChar * 2)) / oneChar;
@@ -379,10 +362,6 @@ public class ScreenConsole extends Screen {
         }
 
         private int @NotNull[] getCursor() {
-            if (this.fontRenderer == null) {
-                return new int[2];
-            }
-
             final @NotNull String @NotNull[] split = this.text.split("\n", -1);
 
             int cursor = this.editor.getCursor();
@@ -443,7 +422,6 @@ public class ScreenConsole extends Screen {
         Keyboard.enableRepeatEvents(true);
 
         this.logRenderer.init(this.mc, this.width - PADDING * 2);
-        this.inputRenderer.init(this.mc);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
index 9809e3626..9c5823e46 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
@@ -1,18 +1,21 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.render.font.Alignment;
-import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.net.ChatEmotes;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 
 import java.util.Map;
 
 public class ScreenFontTest extends Screen{
+    private static final char[] chars = {'H', 'e', 'l', 'l', 'o', ' ', 'W', 'o', 'r', 'l', 'd', '!'};
+    private static final @NotNull NamespaceID testId = new NamespaceID("test", "value");
+    private static final @NotNull StringBuilder builder = new StringBuilder();
     public double scroll = 0;
     public ScreenFontTest(final @Nullable Screen parent) {
         super(parent);
@@ -22,73 +25,64 @@ public class ScreenFontTest extends Screen{
         renderTexturedBackground();
         super.render(mx, my, partialTick);
 
-        scroll += Mouse.getDWheel() * fontRenderer.fontHeight()/2;
+        this.scroll += Mouse.getDWheel() * this.fontRenderer.getFont().fontHeight();
 
-//        drawStringCenteredNoShadow(this.mc.font, "§l§oBetter than Adventure!", this.width /2, this.height /2 - 30, 0x22ffffff);
-//        this.fontRenderer.renderCentered(Tessellator.instance,  "§l§oBetter than Adventure!", this.width /2, this.height /2 - 20, 0, false, 0xffffffL, null, null, null);
+        final int maxWidth = (int) (width/1.2);
 
-//        FontHelper.renderWidthConstrained(Tessellator.instance,
-//            "§bLorem ipsum dolor sit amet, §+§3consectetur adipiscing elit, sed do eiusmod tempor incididunt §+§1ut labore et §+§rdolore magna aliqua.§- Ut enim §-ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut §-aliquip ex ea commodo consequat. Duis aute irure dolor in §+§rreprehenderit in voluptate velit esse cillum dolore §-eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. \n Test String1!",
-//            (this.width/2) - 120, this.height/2, 240).setColor(0xFFAAFF).call(this.fontRenderer);
-//
-//        FontHelper.render(Tessellator.instance, "Test String2!", (this.width/2) - 120, FontHelper.getLastEndingY()).call(this.fontRenderer);
-//        FontHelper.render(Tessellator.instance, "Test String3!", (this.width/2) - 120, FontHelper.getLastEndingY()).setColor(0xFF0000).call(this.fontRenderer);
-//        FontHelper.render(Tessellator.instance, "Test String4!", (this.width/2) - 120, FontHelper.getLastEndingY()).call(this.fontRenderer);
-
-//        StringBuilder builder = new StringBuilder();
-//        for (char i = 0; i < 256; i++) {
-//            builder.append(i);
-//            if (i != 0 && i % 16 == 0) {
-//                builder.append("\n");
-//            }
-//        }
-//
-//        FontHelper.renderWidthConstrained(Tessellator.instance, builder, (this.width/2) - 120, FontHelper.getLastEndingY(), Integer.MAX_VALUE).call(this.fontRenderer);
-
-        drawRect((width - 400)/2, 10, (width + 400)/2, 400, 0xFF232323);
-        long start = System.currentTimeMillis();
-        final StringBuilder builder = new StringBuilder("§0§0§0§0§<AAAAFF>");
+        drawRect((this.width - maxWidth)/2, 0, (this.width + maxWidth)/2, this.height, 0xFF232323);
+        final long start = System.currentTimeMillis();
+        builder.setLength(0);
+        builder.append("§0§0§0§0§<AAAAFF>");
         for (int i = 0; i < 1000; i++) {
             builder.append("a");
         }
         builder.append("\n").append(ChatAllowedCharacters.ALLOWED_CHARACTERS);
-        builder.append("\n").append("Obfuscation test: §kTEST STRING §r§<FFAAAA> Static Text");
+        builder.append("\n").append("§rItalic test: §oTEST STRING");
+        builder.append("\n").append("§rBold test: §lTEST STRING");
+        builder.append("\n").append("§rUnderline test: §nTEST STRING");
+        builder.append("\n").append("§rStrikethrough test: §mTEST STRING");
+        builder.append("\n").append("§rObfuscation test: §kTEST STRING Static §rText");
+        builder.append("\n").append("§rAll No Obf test: §o§l§n§mTEST STRING");
+        builder.append("\n").append("§rAll test: §k§o§l§n§mTEST STRING§r");
         builder.append("\n").append("\tTab");
         builder.append("\n").append("\t\tTabTab");
         builder.append("\n").append("   TripleSpace");
 
-        for (Map.Entry<String, Character> entry : ChatEmotes.getEmotes().entrySet()) {
+        for (final Map.Entry<String, Character> entry : ChatEmotes.getEmotes().entrySet()) {
             builder.append("\n").append(entry.getKey().replace(":", "")).append(": ").append(entry.getValue());
         }
 
         builder.append("\n§bLorem ipsum dolor sit amet, §+§3consectetur adipiscing elit, sed do eiusmod tempor incididunt §+§1ut labore et §+§rdolore magna aliqua.§- Ut enim §-ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut §-aliquip ex ea commodo consequat. Duis aute irure dolor in §+§rreprehenderit in voluptate velit esse cillum dolore §-eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. \nTest String1!");
-        FontHelper.renderWidthConstrained(Tessellator.instance, builder, (width - 400)/2, (int) (10 + scroll), 400).setAlignment(Alignment.LEFT).setColor(0xFFAAFF).setShadow().call(this.fontRenderer);
+        this.fontRenderer.renderWidthConstrained(Tessellator.instance, builder, (this.width - maxWidth)/2, (int) (10 + this.scroll), maxWidth).setAlignment(Alignment.LEFT).setColor(0xFFAAFF).setShadow().call();
         final long bigStringRenderTime = System.currentTimeMillis() - start;
-        FontHelper.render(Tessellator.instance, "" + bigStringRenderTime/1000f, (width - 400)/2, FontHelper.getLastEndingY() + 20).call(this.fontRenderer);
+        this.fontRenderer.render(Tessellator.instance, bigStringRenderTime/1000f + "s", (this.width - maxWidth)/2, this.fontRenderer.getLastEndingY() + 20).call();
 
         final long memTotal = Runtime.getRuntime().totalMemory();
         final long memFree = Runtime.getRuntime().freeMemory();
         final long memUsed = memTotal - memFree;
 
-        FontHelper.render(Tessellator.instance, "" + memUsed/(1024 * 1024) + "MB", (width - 400)/2, FontHelper.getLastEndingY() + 20).call(this.fontRenderer);
+        this.fontRenderer.render(Tessellator.instance, memUsed/(1024 * 1024) + "MB", (this.width - maxWidth)/2, this.fontRenderer.getLastEndingY()).call();
+
+        this.fontRenderer.render(Tessellator.instance, "Unicode: Better than Adventure", (this.width - maxWidth)/2, this.fontRenderer.getLastEndingY()).setFont(Fonts.UNICODE).call();
+        this.fontRenderer.render(Tessellator.instance, "Default: Better than Adventure", (this.width - maxWidth)/2, this.fontRenderer.getLastEndingY()).setFont(Fonts.DEFAULT).call();
+        this.fontRenderer.render(Tessellator.instance, "Monospace: Better than Adventure", (this.width - maxWidth)/2, this.fontRenderer.getLastEndingY()).setFont(Fonts.MONOSPACE).call();
+
+        int y = this.fontRenderer.getLastEndingY() + 10;
+        this.fontRenderer.render(Tessellator.instance, "String: ", (this.width - maxWidth)/2, y).setColor(0xFFAAFF).call(); this.fontRenderer.render(Tessellator.instance, "Test String", this.fontRenderer.getLastEndingX(), y).call(); y = this.fontRenderer.getLastEndingY();
+        this.fontRenderer.render(Tessellator.instance, "null (Object): ", (this.width - maxWidth)/2, y).setColor(0xFFAAFF).call(); this.fontRenderer.render(Tessellator.instance, (Object) null, this.fontRenderer.getLastEndingX(), y).call(); y = this.fontRenderer.getLastEndingY();
+        this.fontRenderer.render(Tessellator.instance, "object: ", (this.width - maxWidth)/2, y).setColor(0xFFAAFF).call(); this.fontRenderer.render(Tessellator.instance, testId, this.fontRenderer.getLastEndingX(), y).call(); y = this.fontRenderer.getLastEndingY();
+        this.fontRenderer.render(Tessellator.instance, "boolean: ", (this.width - maxWidth)/2, y).setColor(0xFFAAFF).call(); this.fontRenderer.render(Tessellator.instance, true, this.fontRenderer.getLastEndingX(), y).call(); y = this.fontRenderer.getLastEndingY();
+        this.fontRenderer.render(Tessellator.instance, "int: ", (this.width - maxWidth)/2, y).setColor(0xFFAAFF).call(); this.fontRenderer.render(Tessellator.instance, 15, this.fontRenderer.getLastEndingX(), y).call(); y = this.fontRenderer.getLastEndingY();
+        this.fontRenderer.render(Tessellator.instance, "long: ", (this.width - maxWidth)/2, y).setColor(0xFFAAFF).call(); this.fontRenderer.render(Tessellator.instance, 1500L, this.fontRenderer.getLastEndingX(), y).call(); y = this.fontRenderer.getLastEndingY();
+        this.fontRenderer.render(Tessellator.instance, "char: ", (this.width - maxWidth)/2, y).setColor(0xFFAAFF).call(); this.fontRenderer.render(Tessellator.instance, 'a', this.fontRenderer.getLastEndingX(), y).call(); y = this.fontRenderer.getLastEndingY();
+        this.fontRenderer.render(Tessellator.instance, "float: ", (this.width - maxWidth)/2, y).setColor(0xFFAAFF).call(); this.fontRenderer.render(Tessellator.instance, 0.5f, this.fontRenderer.getLastEndingX(), y).call(); y = this.fontRenderer.getLastEndingY();
+        this.fontRenderer.render(Tessellator.instance, "double: ", (this.width - maxWidth)/2, y).setColor(0xFFAAFF).call(); this.fontRenderer.render(Tessellator.instance, 0.5, this.fontRenderer.getLastEndingX(), y).call(); y = this.fontRenderer.getLastEndingY();
+        this.fontRenderer.render(Tessellator.instance, "char array: ", (this.width - maxWidth)/2, y).setColor(0xFFAAFF).call(); this.fontRenderer.render(Tessellator.instance, chars, this.fontRenderer.getLastEndingX(), y).call(); y = this.fontRenderer.getLastEndingY();
 
         final double mouseX = (double) (Mouse.getX() * this.mc.resolution.getScaledWidthScreenCoords()) / this.mc.resolution.getWidthScreenCoords();
         final double mouseY =  (this.mc.resolution.getScaledHeightScreenCoords() - (double) (Mouse.getY() * this.mc.resolution.getScaledHeightScreenCoords()) / this.mc.resolution.getHeightScreenCoords());
 
-        FontHelper.renderDouble(Tessellator.instance, "Double Precision", mouseX - this.fontRenderer.stringWidthDouble("Double Precision") - 3, mouseY - 6).setShadow().call(this.fontRenderer);
-        FontHelper.render(Tessellator.instance, "Int Precision", (int) (mouseX + 3), (int) (mouseY - 5)).setShadow().call(this.fontRenderer);
-
-//        StringBuilder message = new StringBuilder("<Useless7695> ");
-//        for (char i = '!'; i <= '~'; i++) {
-//            message.append(i);
-//        }
-//        for (char i = '!'; i <= '~'; i++) {
-//            message.append(i);
-//        }
-//        for (char i = '!'; i <= '~'; i++) {
-//            message.append(i);
-//        }
-//
-//        FontHelper.renderWidthConstrained(Tessellator.instance, message, (this.width - 320)/2, 10, 320).setShadow().call(this.fontRenderer);
+        this.fontRenderer.renderDouble(Tessellator.instance, "Double Precision", mouseX - this.fontRenderer.stringWidthDouble("Double Precision") - 3, mouseY - 6).setShadow().call();
+        this.fontRenderer.render(Tessellator.instance, "Int Precision", (int) (mouseX + 3), (int) (mouseY - 5)).setShadow().call();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMissingMinecraft.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMissingMinecraft.java
index 0922fba33..9f5a24383 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMissingMinecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMissingMinecraft.java
@@ -22,7 +22,7 @@ public class ScreenMissingMinecraft extends Screen {
         buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120 + 12, i.translateKey("gui.no_minecraft.button.quit")));
         ClickableLabelElement installLabel = new ClickableLabelElement(1, width / 2 - 170, (height / 4 - 60) + 60 + 64, downloadString, 0x7C99EA);
         buttons.add(installLabel);
-        buttons.add(new ClickableLabelElement(2, 0,  height - mc.font.fontHeight() - 4, i.translateKey("gui.main_menu.button.discord"), 0x5865F2));
+        buttons.add(new ClickableLabelElement(2, 0,  height - mc.font.getFont().fontHeight() - 4, i.translateKey("gui.main_menu.button.discord"), 0x5865F2));
     }
     @Override
     public void render(int mx, int my, float partialTick)
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
index a87899095..cf5488740 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
@@ -166,7 +166,7 @@ public class ScreenSoundTest extends Screen {
         builder.append(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.id", currentEntry == null ? null : currentEntry.getEventID())).append("\n");
         builder.append(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.subtitle", currentEntry == null ? null : currentEntry.getSubtitleKey(), currentEntry == null ? null : currentEntry.getSubtitleTranslated())).append("\n");
 //        builder.append(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.url", String.valueOf(currentEntry == null ? null : (showURL ? currentEntry.url : "REDACTED")))).append("\n");
-        fontRenderer.renderWidthConstrained(Tessellator.instance, builder, 5, top + 30, 0, true, 0xBBBBBB, width - 10, Alignment.LEFT, null, null, null);
+        this.fontRenderer.renderWidthConstrained(Tessellator.instance, builder, 5, this.top + 30, this.width - 10).setShadow().setColor(0xBBBBBB).call();
     }
     @Override
     public void renderBackground() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java b/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
index 617eeccf8..3010e37cb 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
@@ -139,7 +139,7 @@ public class TextFieldElement extends Gui implements ITextField
         {
             boolean drawCursor = isFocused && (cursorCounter / 6) % 2 == 0;
             int cursor = editor.getCursor();
-            int maxDisplayableChars = this.width / fontRenderer.charWidth('_');
+            int maxDisplayableChars = this.width / fontRenderer.getFont().charWidth('_');
 
             if(text.length() <= maxDisplayableChars-1){
                 drawStringShadow(fontRenderer, text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index 4168675e6..58cf00879 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -8,7 +8,6 @@ import com.google.gson.stream.JsonReader;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -96,7 +95,7 @@ public class TooltipElement extends Gui
         drawBackground(x, y, x + width, y + height);
 //        drawRect(x, y, x + width, y + height, 0xFFFFFFFF);
 
-        FontHelper.renderWidthConstrained(Tessellator.instance, chars, x + padding, y + padding, maxWidth).call(this.fontRenderer);
+        this.fontRenderer.renderWidthConstrained(Tessellator.instance, chars, x + padding, y + padding, maxWidth).call();
     }
     public int getPadding(){
         return 0;
